<!----------------------------------------------------------------------------------------------------------------------
  -- Requests Page
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="requests-page">
        <div class="request-page-col p-2">
            <RequestForm class="w-100 h-100" />
        </div>
        <div class="request-page-col p-2">
            <ResponseForm class="w-100 h-100" />
        </div>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
    #requests-page {
        display: flex;
        flex-direction: column;

        .request-page-col {
            width: 100%;
        }

        @media screen and (min-width: 1172px) and (min-height: 470px)
        {
            flex-direction: row !important;
            height: calc(100vh - 100px);

            .request-page-col {
              width: 50% !important;
            }
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { watch } from 'vue';
    import { useRouter } from 'vue-router';

    import { useObservable } from '../lib/composables/rxjs.js';

    // Managers
    import authMan from '../lib/managers/auth.js';

    // Components
    import RequestForm from '../components/requests/requestForm.vue';
    import ResponseForm from '../components/requests/responseForm.vue';

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const router = useRouter();

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const authEnabled = useObservable(authMan.authEnabled$);
    const account = useObservable(authMan.account$);

    //------------------------------------------------------------------------------------------------------------------
    // Watches
    //------------------------------------------------------------------------------------------------------------------

    // When/if the account is set, redirect to the requests page
    watch(account, (newAccount) =>
    {
        if(authEnabled.value && !newAccount)
        {
            router.push('/');
        }
    }, { immediate: true });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
